var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw new Error('Dynamic require of "' + x + '" is not supported');
});
var __commonJS = (cb, mod) => function __require2() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// ../libuild-utils/lib/assert.js
var require_assert = __commonJS({
  "../libuild-utils/lib/assert.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isEmptyObject = exports.isObject = exports.isDef = exports.isEmpty = void 0;
    function isEmpty(value) {
      return value == null;
    }
    exports.isEmpty = isEmpty;
    function isDef(x) {
      return x !== void 0 && x !== null;
    }
    exports.isDef = isDef;
    function isObject(value) {
      return Object.prototype.toString.call(value) === "[object Object]";
    }
    exports.isObject = isObject;
    function isEmptyObject(value) {
      if (!isObject(value)) {
        return false;
      }
      const keys = Object.keys(value);
      return keys.length === 0;
    }
    exports.isEmptyObject = isEmptyObject;
  }
});

// ../libuild-utils/lib/catchUnhandledReject.js
var require_catchUnhandledReject = __commonJS({
  "../libuild-utils/lib/catchUnhandledReject.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.catchUnhandledReject = void 0;
    var catchUnhandledReject = (f, callback) => {
      return f.catch(callback);
    };
    exports.catchUnhandledReject = catchUnhandledReject;
  }
});

// ../libuild-utils/lib/deepMerge.js
var require_deepMerge = __commonJS({
  "../libuild-utils/lib/deepMerge.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.deepMerge = void 0;
    var assert_1 = require_assert();
    function deepMerge(lower, higher) {
      if (arguments.length !== 2 || !(0, assert_1.isObject)(lower) || !(0, assert_1.isObject)(higher)) {
        throw Error(`${lower} and ${higher} must be Object`);
      }
      const merged = Object.assign({}, lower);
      for (const key in higher) {
        const value = higher[key];
        if (value == null) {
          continue;
        }
        const existing = merged[key];
        if (Array.isArray(existing) && Array.isArray(value)) {
          merged[key] = [...existing, ...value];
        } else if ((0, assert_1.isObject)(existing) && (0, assert_1.isObject)(value)) {
          merged[key] = deepMerge(existing, value);
        } else {
          merged[key] = value;
        }
      }
      return merged;
    }
    exports.deepMerge = deepMerge;
  }
});

// ../libuild-utils/lib/mapValue.js
var require_mapValue = __commonJS({
  "../libuild-utils/lib/mapValue.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mapValue = void 0;
    function mapValue(obj, mapper) {
      if (typeof obj !== "object") {
        throw Error("type error, `obj` must be a object.");
      }
      return Object.fromEntries(Object.entries(obj).map(([key, value]) => [key, mapper(value)]));
    }
    exports.mapValue = mapValue;
  }
});

// ../libuild-utils/lib/resolvePathAndQuery.js
var require_resolvePathAndQuery = __commonJS({
  "../libuild-utils/lib/resolvePathAndQuery.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isJsLoader = exports.isJsExt = exports.isStyleExt = exports.resolvePathAndQuery = void 0;
    var querystring_1 = __importDefault(__require("querystring"));
    var resolvePathAndQuery2 = (originalPath) => {
      const [filePath, queryStr] = originalPath.split("?");
      const query = querystring_1.default.parse(queryStr !== null && queryStr !== void 0 ? queryStr : "");
      for (const key of Object.keys(query)) {
        if (query[key] === "") {
          query[key] = true;
        }
      }
      return {
        query,
        rawQuery: queryStr,
        originalFilePath: filePath
      };
    };
    exports.resolvePathAndQuery = resolvePathAndQuery2;
    function isStyleExt(path) {
      return /\.(c|le|sa|sc)ss(\?.*)?$/.test(path);
    }
    exports.isStyleExt = isStyleExt;
    function isJsExt2(path) {
      return /\.(m|c)?(j|t)sx?(\?.*)?$/.test(path);
    }
    exports.isJsExt = isJsExt2;
    function isJsLoader2(loader) {
      return loader === "js" || loader === "ts" || loader === "tsx" || loader === "jsx";
    }
    exports.isJsLoader = isJsLoader2;
  }
});

// ../libuild-utils/lib/index.js
var require_lib = __commonJS({
  "../libuild-utils/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_assert(), exports);
    __exportStar(require_catchUnhandledReject(), exports);
    __exportStar(require_deepMerge(), exports);
    __exportStar(require_mapValue(), exports);
    __exportStar(require_resolvePathAndQuery(), exports);
  }
});

// src/index.ts
var import_libuild_utils = __toESM(require_lib());
var babelPresetPlugin = (preset = {}, options = {}) => {
  return {
    name: "libuild:babel-preset",
    apply(compiler) {
      compiler.hooks.transform.tapPromise("babel", (args) => __async(this, null, function* () {
        const { originalFilePath } = (0, import_libuild_utils.resolvePathAndQuery)(args.path);
        if ((0, import_libuild_utils.isJsExt)(originalFilePath) || (0, import_libuild_utils.isJsLoader)(args.loader)) {
          const isTsx = args.loader === "tsx" || /\.tsx$/i.test(originalFilePath);
          const { plugins, presets } = normalizeBabel(preset, isTsx);
          const result = yield __require("@babel/core").transformAsync(args.code, __spreadProps(__spreadValues({}, options), {
            exclude: [/\bcore-js\b/],
            inputSourceMap: false,
            filename: originalFilePath,
            sourceFileName: originalFilePath,
            sourceMaps: Boolean(compiler.config.sourceMap),
            babelrc: false,
            configFile: false,
            compact: false,
            presets: [...presets, ...options.presets || []],
            plugins: [...plugins, ...options.plugins || []]
          }));
          return __spreadProps(__spreadValues({}, args), {
            code: result == null ? void 0 : result.code,
            map: result == null ? void 0 : result.map
          });
        }
        return args;
      }));
    }
  };
};
function normalizeBabel(preset, isTsx) {
  const presets = [[__require("@babel/preset-typescript"), isTsx ? { isTSX: true, allExtensions: true } : {}]];
  if (preset.react || preset.import) {
    presets.push([__require("@babel/preset-react"), preset.react]);
  }
  const plugins = [];
  if (preset.import) {
    if (Array.isArray(preset.import)) {
      plugins.push(
        ...preset.import.map((o, i) => {
          return [__require("babel-plugin-import"), o, String(i)];
        })
      );
    } else if (typeof preset.import === "object") {
      plugins.push([__require("babel-plugin-import"), preset.import]);
    }
  }
  return { presets, plugins };
}
export {
  babelPresetPlugin
};

//# sourceMappingURL=index.js.map